

#ifndef _MC_GRID_3D_SCALAR_MARCHING_CUBE_HPP_
#define _MC_GRID_3D_SCALAR_MARCHING_CUBE_HPP_

#include <MC_grid_3d_scalar.hpp>
#include <vector>
#include <algorithm>

namespace mesh_conv
{
    class MC_mesh_index_vector;
    class MC_int_vector;

    /** \brief helper to apply marching cube on a volume data */
    class MC_grid_3d_scalar_marching_cube
    {

    public:

        // ************************************************ //
        // ************************************************ //
        // SLICE
        // ************************************************ //
        // ************************************************ //

        /** \brief apply marching cube on data */
        static MC_mesh_index_vector marching_cube(const MC_grid_3d_scalar& values,const double& isovalue=0.0);

    private:

        /** \brief add polygons corresponding to the current cell in the mesh */
        static void create_polygon(const std::vector<double>& cell_value,const int& type_of_cube,const MC_int_vector& x,MC_mesh_index_vector* mesh, std::map<MC_int_pair,unsigned int,MC_int_pair_less>* edge_to_vertex_index,const MC_grid_3d_scalar& potential);

        /** /brief helper indexation for the marching cube */
        static int EdgeTable[256];
        /** /brief helper indexation for the marching cube */
        static int TriangulationTable[256][16];
    };

}

#endif
