
#ifndef _MC_GRID_3D_SCALAR_SLICER_HPP_
#define _MC_GRID_3D_SCALAR_SLICER_HPP_

#include <fstream>

#include <MC_double_vector.hpp>
#include <MC_exception.hpp>

namespace mesh_conv
{
    class MC_grid_3d_scalar;
    class MC_mesh_index_vector;

    /** \brief helper class to slice a MC_grid_3d */
    class MC_grid_3d_scalar_slicer
    {
    public:

        // ************************************************ //
        // ************************************************ //
        // SLICE
        // ************************************************ //
        // ************************************************ //

        /** \brief slice along a normal direction and a position
            \return the intensity corresponding to the mesh in the vertex order
        */
        static MC_double_vector slice(const MC_grid_3d_scalar& potential,const MC_mesh_index_vector& mesh);


        // ************************************************ //
        // ************************************************ //
        // TEXTURE
        // ************************************************ //
        // ************************************************ //

        /** \brief helper to export a square slice as a texture in ppm format */
        static void export_square_ppm(std::ofstream& stream,const MC_double_vector& value,const unsigned int& N0,const unsigned int& N1);
        /** \brief helper to export a square slice as a texture in ppm format in a file */
        static void export_square_ppm_file(const std::string& filename,const MC_double_vector& value,const unsigned int& N0,const unsigned int& N1);


    private:

    };
}

#endif
