
#ifndef _MC_POTENTIAL_SPHERE_HPP_
#define _MC_POTENTIAL_SPHERE_HPP_

#include <MC_potential_implicit.hpp>
#include <MC_sphere_geometry.hpp>

namespace mesh_conv
{
    namespace implicit
    {
        class MC_potential_sphere : public MC_potential_implicit
        {
        public:

            // ************************************************ //
            // ************************************************ //
            //  Constructor
            // ************************************************ //
            // ************************************************ //

            /** \brief empty constructor */
            MC_potential_sphere();
            /** \brief direct constructor */
            MC_potential_sphere(const MC_sphere_geometry& sphere);

            /** \brief destructor */
            virtual ~MC_potential_sphere();

            /** \brief clear the internal sphere */
            virtual void clear();

            // ************************************************ //
            // ************************************************ //
            //  Potential computation
            // ************************************************ //
            // ************************************************ //

            /** \brief get potential on a given position */
            virtual double operator()(const MC_v3d& x) const;

            // ************************************************ //
            // ************************************************ //
            //  Internal sphere object
            // ************************************************ //
            // ************************************************ //

            /** \brief get internal sphere geometry */
            const MC_sphere_geometry& sphere() const;
            /** \brief get internal sphere geometry */
            MC_sphere_geometry& sphere();

        private:

            /** \brief store internaly a sphere */
            MC_sphere_geometry sphere_internal;

        };
    }
}

#endif
