
#include <MC_particle_engine.hpp>

namespace mesh_conv
{

    unsigned int MC_particle_engine::id_max=0;

    MC_particle_engine::MC_particle_engine()
            :particles(),time_step(1e-2),dim_spatial_hash(10),dim_spatial_hash_proximity(10)
    {
        spatial_hash=MC_grid_index_spatial_hashing(MC_int_vector(dim_spatial_hash,dim_spatial_hash,dim_spatial_hash));
        spatial_hash_proximity=MC_grid_index_spatial_hashing(MC_int_vector(dim_spatial_hash_proximity,dim_spatial_hash_proximity,dim_spatial_hash_proximity));
    }

    void MC_particle_engine::add(const MC_sphere_physic& new_particle)
    {
        particles.insert(std::make_pair(id_max++,new_particle));
    }

    void MC_particle_engine::evolve(const bool& is_collision_detection,const bool& is_potential)
    {
        MC_v3d gravity=MC_v3d(0,0,-9.81);

        //empty the spatial hash
        if(is_collision_detection==true)
            spatial_hash.clear();
        if(is_potential==true)
            spatial_hash_proximity.clear();



        for(std::map<unsigned int,MC_sphere_physic>::iterator it=particles.begin(),it_end=particles.end();it!=it_end;++it)
        {
            MC_sphere_physic& current_particle=it->second;
            current_particle.force().set_zero();


            // ******************************* //
            // TO DO: ajouter les indice dans la structure acceleratrice
            // spatial_hash.add_sphere(le_centre_en_voxel,la_dimension_en_voxel,it->first);
            // ******************************* //
       }

        for(std::map<unsigned int,MC_sphere_physic>::iterator it=particles.begin(),it_end=particles.end();it!=it_end;++it)
        {
            MC_sphere_physic& current_particle=it->second;
            current_particle.force() = gravity;
            std::set<int> neighboor_index;
            std::set<int> neighboor_index_proximity;
            if(is_collision_detection==true)
            {
                // ******************************* //
                // TO DO: detecter les voisins
                // neighboor_index=spatial_hash.neighboors_index_in_radius(le_centre_en_voxel,le_rayon_en_voxel);
                // ******************************* //
            }
            if(is_potential==true)
            {
                // ******************************* //
                // TO DO: detecter les voisins
                // neighboor_index_proximity=spatial_hash_proximity.neighboors_index_in_radius(le_centre_en_voxel,le_rayon_en_voxel);
                // ******************************* //
            }

            //compute potential force
            if(is_potential==true)
            {

                // ******************************* //
                // TO DO: potential force
                // ******************************* //

            }


            //evolve through time
            current_particle.evolve(time_step);




            //collision response
            if(is_collision_detection==true)
            {
                // ******************************* //
                // TO DO: Collision between pair of particles

                // pour les paires de particules
                //     MC_sphere_physic::constraint_no_collision_sphere(&current_particle,&(autre_particule)));

                // ******************************* //
            }

            //cube constraint
            current_particle.constraint_in_unit_cube();

        }

    }

    const std::map<unsigned int,MC_sphere_physic>& MC_particle_engine::particle_system() const
    {
        return particles;
    }

}
