
#include <MC_potential_sphere.hpp>

namespace mesh_conv
{
    namespace implicit
    {
        MC_potential_sphere::MC_potential_sphere(){}
        MC_potential_sphere::MC_potential_sphere(const MC_sphere_geometry& sphere)
                :sphere_internal(sphere)
        {}
        MC_potential_sphere::~MC_potential_sphere(){}
        double MC_potential_sphere::operator()(const MC_v3d& x) const
        {
            MC_v3d u=sphere_internal.center()-x;
            double d=u.norm()/sphere_internal.radius();

            return 10.0/(d*d);
        }
        void MC_potential_sphere::clear()
        {
            sphere_internal=MC_sphere_geometry();
        }


        const MC_sphere_geometry& MC_potential_sphere::sphere() const
        {return sphere_internal;}
        MC_sphere_geometry& MC_potential_sphere::sphere()
        {return sphere_internal;}
    }
}
