

#include <MC_sphere_geometry.hpp>

namespace mesh_conv
{
    MC_sphere_geometry::MC_sphere_geometry():center_internal(MC_v3d(0,0,0)),radius_internal(1){}
    MC_sphere_geometry::MC_sphere_geometry(const MC_v3d& _center,const double& _radius):center_internal(_center),radius_internal(_radius){}

    MC_v3d& MC_sphere_geometry::center(){return center_internal;}
    const MC_v3d& MC_sphere_geometry::center() const{return center_internal;}

    double& MC_sphere_geometry::radius(){return radius_internal;}
    const double& MC_sphere_geometry::radius() const{return radius_internal;}

    MC_sphere_geometry::MC_sphere_geometry(const MC_sphere_geometry& sphere)
            :center_internal(sphere.center_internal),radius_internal(sphere.radius_internal)
    {}
    bool MC_sphere_geometry::is_collide(const MC_sphere_geometry& sphere)
    {

        double dist_center=(center_internal-sphere.center()).norm();
        double radius_sum=radius_internal+sphere.radius();
        if(dist_center<radius_sum)
            return true;
        return false;
    }

}
