
/*
**    Mesh Converter
**    Copyright (C) 2009  Damien Rohmer
**
**    This program is free software: you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation, either version 3 of the License, or
**    (at your option) any later version.
**
**   This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _MC_IO_OFF_HPP_
#define _MC_IO_OFF_HPP_

#include <iostream>
#include <fstream>

namespace mesh_conv
{

    class MC_v3d_vector;
    class MC_connectivity_index;
    class MC_mesh_index_vector;

    /** \brief Helper class to read and write mesh in a off format */
    class MC_io_off
    {

    public:

        /** \brief read an input stream in a off format
            \return <point_set,connectivity> */
        static std::pair <MC_v3d_vector,MC_connectivity_index> read_off(std::istream& stream);
        /** \brief read an input file in a off format
            \return <point_set,connectivity> */
        static std::pair <MC_v3d_vector,MC_connectivity_index> read_off_file(const std::string& string_file);

        /** \brief write input stream in off format */
        static std::ostream& write_off(std::ostream& stream,const MC_mesh_index_vector& to_write);
        /** \brief write input stream into a file */
        static const MC_mesh_index_vector& write_off_file(const std::string& string_file,const MC_mesh_index_vector& to_write);




    private:

    };
}

#endif
