
#ifndef _MC_POTENTIAL_IMPLICIT_HPP_
#define _MC_POTENTIAL_IMPLICIT_HPP_

namespace mesh_conv
{
    class MC_v3d;

    namespace implicit
    {
        /** Virtual class for implicit surface */
        class MC_potential_implicit
        {

        public:

            //************************************************//
            //************************************************//
            //Constructor
            //************************************************//
            //************************************************//

            /** \brief destructor */
            virtual ~MC_potential_implicit(){}

            /** \brief delete every internal elements */
            virtual void clear()=0;

            //************************************************//
            //************************************************//
            //Potential computation
            //************************************************//
            //************************************************//

            /** \brief get potential on a given position */
            virtual double operator()(const MC_v3d& x) const=0;


        private:

        };
    }
}

#endif
