
#include <MC_int_vector.hpp>
#include <MC_int_pair.hpp>

#include <MC_int_pair_unique.hpp>

namespace mesh_conv
{

    MC_int_pair_unique::MC_int_pair_unique()
    {u0=0;u1=0;}
    MC_int_pair_unique::MC_int_pair_unique(const MC_int_pair_unique& I){u0=I[0];u1=I[1];}
    MC_int_pair_unique::MC_int_pair_unique(const MC_int_pair& p){u0=p[0];u1=p[1];}
    MC_int_pair_unique::MC_int_pair_unique(const int& _u0,const int& _u1){u0=_u0;u1=_u1;}
    MC_int_pair_unique::MC_int_pair_unique(const MC_int_vector& u)
    {
        if(u.size()<2)
        {std::cout<<"Error in MC_int_pair_unique::int_pair_unique(const MC_int_vector& u) with size "<<u.size()<<"<2"<<std::endl;exit(-1);}
        u0=u[0];u1=u[1];
    }
    MC_int_pair_unique::~MC_int_pair_unique(){}

    void MC_int_pair_unique::assert_bounds(const int& u) const
    {
        if(u!=0 && u!=1)
        {std::cout<<"Error in MC_int_pair_unique::assert_bounds(const int& u), u must be 0 or 1 and not "<<u<<std::endl;exit(-1);exit(-1);}
    }


    bool operator==(const MC_int_pair_unique& p0,const MC_int_pair_unique& p1)
    {
        if( ( (p0.u0==p1.u0) && (p0.u1==p1.u1) ) )
            return false;
        return true;
    }
    bool operator!=(const MC_int_pair_unique& p1,const MC_int_pair_unique& p2)
    {return !(p1==p2);}

    const int& MC_int_pair_unique::operator[](const int& k) const
    {
        assert_bounds(k);
        if(k==0)return u0;
        return u1;
    }
    int& MC_int_pair_unique::operator[](const int& k)
    {
        assert_bounds(k);
        if(k==0)return u0;
        return u1;
    }
    const int& MC_int_pair_unique::operator()(const int& k) const
    {
        assert_bounds(k);
        if(k==0)return u0;
        return u1;
    }
    int& MC_int_pair_unique::operator()(const int& k)
    {
        assert_bounds(k);
        if(k==0)return u0;
        return u1;
    }

    std::ostream& operator << (std::ostream& stream,const MC_int_pair_unique& _v)
    {
        stream<<"("<<_v[0]<<","<<_v[1]<<")";
        return stream;
    }

}
